#include "indigo.h"
#include <stdlib.h>
#include <string.h>

OCCAM_API int occamFreeImage(OccamImage* image) {
  if (!image)
    return OCCAM_API_SUCCESS;
  if (--image->refcnt<=0) { // * TODO: atomic operation for subtraction
    if (image->backend == OCCAM_LOCAL) {
      delete [] image->data[0];
      delete [] image->data[1];
      delete [] image->data[2];
    }

    else if (image->backend == OCCAM_OPENGL) {
      // * TODO
    }

    if (image->cid)
      free(image->cid);

    delete image;
  }
  return OCCAM_API_SUCCESS;
}

OCCAM_API int occamCopyImage(const OccamImage* image, OccamImage** new_image, int deep_copy) {
  if (image->backend != OCCAM_LOCAL)
    return OCCAM_API_INVALID_PARAMETER;

  if (deep_copy) {
    *new_image = new OccamImage(*image);
    (*new_image)->refcnt = 1;
    if (image->cid)
      (*new_image)->cid = strdup(image->cid);

    int c0_height = image->height;
    int c1_height = 0;
    int c2_height = 0;
    int c0_size = image->step[0] * c0_height;
    int c1_size = image->step[1] * c1_height;
    int c2_size = image->step[2] * c2_height;

    (*new_image)->data[0] = c0_size ? new uint8_t[c0_size] : 0;
    (*new_image)->data[1] = c1_size ? new uint8_t[c1_size] : 0;
    (*new_image)->data[2] = c2_size ? new uint8_t[c2_size] : 0;
    if ((*new_image)->data[0])
      memcpy((*new_image)->data[0],image->data[0],c0_size);
    if ((*new_image)->data[1])
      memcpy((*new_image)->data[1],image->data[1],c1_size);
    if ((*new_image)->data[2])
      memcpy((*new_image)->data[2],image->data[2],c2_size);
  } else {
    ++((OccamImage*)image)->refcnt; // TODO: atomic operation for increment
    *new_image = (OccamImage*)image;
  }

  return OCCAM_API_SUCCESS;
}

